"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

Licence: MIT
"""
import typing
from PyQt6 import QtCore
import datetime
from PyQt6.QtWidgets import *


class QTimeEdit(QDateTimeEdit):
    """
    https://doc.qt.io/qt-6/qtimeedit.html

    **Detailed Description**

    ![](images/windows-timeedit.png)

    Many of the properties and functions provided by QTimeEdit are implemented
    in **QDateTimeEdit** . These are the relevant properties of this class:

    * **time**  holds the time displayed by the widget.
      * **minimumTime**
    defines the minimum (earliest) time that can be set by the user.
      *
    **maximumTime**  defines the maximum (latest) time that can be set by the
    user.
      * **displayFormat**  contains a string that is used to format the
    time displayed in the widget.

    **See also** **QDateEdit**  and **QDateTimeEdit** .
    """

    @typing.overload
    def __init__(self, parent: typing.Optional[QWidget] = ...) -> None:
        """
        https://doc.qt.io/qt-6/qtimeedit.html#QTimeEdit

        **QTimeEdit::QTimeEdit(QWidget * parent = nullptr)**

        Constructs an empty time editor with a **parent**.
        """
        ...

    @typing.overload
    def __init__(
        self,
        time: typing.Union[QtCore.QTime, datetime.time],
        parent: typing.Optional[QWidget] = ...,
    ) -> None:
        """
        https://doc.qt.io/qt-6/qtimeedit.html#QTimeEdit-1

        **QTimeEdit::QTimeEdit(QTime time , QWidget * parent = nullptr)**

        Constructs an empty time editor with a **parent**. The time is set to
        **time**.
        """
        ...
